#!/usr/bin/env bash

set -eu
BB_BUILD_TYPES=(debug_none debug soft_optimize optimize_for_speed optimize_for_size aggressively_optimize_for_speed aggressively_optimize_for_size)
HAS_DEBUG_INFOS=(di no_di)
BASE_PATH=$HOME/bloat-buster-artifacts/$(git rev-parse --abbrev-ref HEAD)/$(git rev-parse HEAD)

for BB_BUILD_TYPE in "${BB_BUILD_TYPES[@]}"; do
    for HAS_DEBUG_INFO in "${HAS_DEBUG_INFOS[@]}"; do
        DEBUG_COMPILER_PATH=$BASE_PATH/Debug/cache/debug_none_di/compiler/${BB_BUILD_TYPE}_${HAS_DEBUG_INFO}/compiler
        RELEASE_COMPILER_PATH=$BASE_PATH/Release/cache/debug_none_di/compiler/${BB_BUILD_TYPE}_${HAS_DEBUG_INFO}/compiler
        DEBUG_HASH=$(sha256sum $DEBUG_COMPILER_PATH)
        RELEASE_HASH=$(sha256sum $RELEASE_COMPILER_PATH)
        if [[ "$DEBUG_HASH" != "$RELEASE_HASH" ]]; then
            echo $DEBUG_COMPILER_HASH
            echo $RELEASE_COMPILER_HASH
            exit 1
        fi
    done
done
